#!/usr/bin/perl
use Mysql;

#    ADCenter SQL v1.7 - ads management software
#    Copyright (C) 1998-2010  T&D Systems, Inc.
#    http://www.td-systems.com/
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.

######################################################################
# Variables Section                                                  #
######################################################################
# Reading variables from file
open (F, "<adc.cfg");
@commands=<F>;
close (F);
foreach (@commands)
{
	eval $_;
}
$dbh=Mysql->connect($mysqlhost,$mysqldb,$mysqllogin,$mysqlpassword);

######################################################################
# Main Section                                                       #
######################################################################
# Get data
if ($ENV{CONTENT_LENGTH}>0){sysread(STDIN,$data,$ENV{CONTENT_LENGTH});}
else {($data=$ENV{QUERY_STRING});}
@data=split("&",$data);
foreach (@data)
{
	/([^=]+)=(.*)/ && do
	{
		($field,$value)=($1,$2);
		$value=~s/\+/ /g;
		$value=~s/%([0-9a-fA-F]{2})/pack('C',hex($1))/eg;
		if ($data{$field}){$data{$field}="$data{$field},$value";}
		else {$data{$field}=$value;}
	}
}
$encline=crypt($data{name},$data{name}).":".crypt($data{password},$data{password});
&admsub if ($encline eq "$alogin:$apassword");

# Authorizing and processing
$sth=$dbh->query("LOCK TABLES adc_users READ") if ($locktables);
$sth=$dbh->query("SELECT uid,icred,ccred FROM adc_users WHERE (username='$data{name}' AND password='$data{password}')");
($uid,$impres,$cli)=$sth->fetchrow;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
unless ($uid)
{
	&closedb;
	open (F,"<$adcpath/template/errauth.tpl");
	@htmlpage=<F>;
	close (F);
	$htmlpage=join("",@htmlpage);
	$htmlpage="print qq~$htmlpage~;";
	print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
	print "content-type: text/html\n\n";
	eval $htmlpage;
	exit;
}
&success;

######################################################################
# Subrotines Section                                                 #
######################################################################
sub success
{
$sth=$dbh->query("LOCK TABLES adc_banners READ") if ($locktables);
$sth=$dbh->query("SELECT bid,urltb,bcode FROM adc_banners WHERE uid=$uid");
while(($bid,$urltb,$bcode)=$sth->fetchrow)
{
	push(@bid,$bid);
	$urltb[$bid]=$urltb;
	$bcode[$bid]=$bcode;
}
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
foreach $ban(@bid)
{
@genimp=();
@genclc=();
$genimp=0;
$genclc=0;
if ($bcode[$ban])
{
	$bv="<center>$bcode[$ban]</center>";
}
elsif ($urltb[$ban])
{
	$bv="<center><img src=\"$urltb[$ban]\"></center>";
}
else
{
	if (-e "$adcpath/banners/$ban.gif")
	{
		$bv="<center><img src=\"$adcenter/banners/$ban.gif\"></center>";
	}
	else
	{
		$bv="<center><img src=\"$adcenter/banners/$ban.jpg\"></center>";
	}
}
$sth=$dbh->query("LOCK TABLES adc_imp READ") if ($locktables);
$sth=$dbh->query("SELECT SUM(adc_imp.h00),SUM(adc_imp.h01),SUM(adc_imp.h02),SUM(adc_imp.h03),SUM(adc_imp.h04),SUM(adc_imp.h05),SUM(adc_imp.h06),SUM(adc_imp.h07),SUM(adc_imp.h08),SUM(adc_imp.h09),SUM(adc_imp.h10),SUM(adc_imp.h11),SUM(adc_imp.h12),SUM(adc_imp.h13),SUM(adc_imp.h14),SUM(adc_imp.h15),SUM(adc_imp.h16),SUM(adc_imp.h17),SUM(adc_imp.h18),SUM(adc_imp.h19),SUM(adc_imp.h20),SUM(adc_imp.h21),SUM(adc_imp.h22),SUM(adc_imp.h23) FROM adc_imp WHERE (uid=$uid AND bid=$ban)");
@genimp=$sth->fetchrow;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
foreach(@genimp){$genimp+=$_;}
$timp+=$genimp;
$sth=$dbh->query("LOCK TABLES adc_clc READ") if ($locktables);
$sth=$dbh->query("SELECT SUM(adc_clc.h00),SUM(adc_clc.h01),SUM(adc_clc.h02),SUM(adc_clc.h03),SUM(adc_clc.h04),SUM(adc_clc.h05),SUM(adc_clc.h06),SUM(adc_clc.h07),SUM(adc_clc.h08),SUM(adc_clc.h09),SUM(adc_clc.h10),SUM(adc_clc.h11),SUM(adc_clc.h12),SUM(adc_clc.h13),SUM(adc_clc.h14),SUM(adc_clc.h15),SUM(adc_clc.h16),SUM(adc_clc.h17),SUM(adc_clc.h18),SUM(adc_clc.h19),SUM(adc_clc.h20),SUM(adc_clc.h21),SUM(adc_clc.h22),SUM(adc_clc.h23) FROM adc_clc WHERE (uid=$uid AND bid=$ban)");
@genclc=$sth->fetchrow;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
foreach(@genclc){$genclc+=$_;}
$tclc+=$genclc;
if ($genimp!=0){$genrat=$genclc/$genimp;}
else {$genrat=0;}
$genrat=$genrat*100;
$genrat=substr($genrat,0,5);
$result.=qq~
<tr><td width="450">
$bv
<table border="0" width="100%" cellpadding="0" bgcolor="#E0E0E0">
<tr><td width="40%" valign="top"><font size=2><b>Impressions</b></font></td><td width="60%" align="right"><font size=2>$genimp</font></td></tr>
<tr><td width="40%" bgcolor="#C0C0C0" valign="top"><font size=2><b>Clicks</b></font></td><td width="60%" align="right" bgcolor="#C0C0C0"><font size=2>$genclc</font></td></tr>
<tr><td width="40%" valign="top"><font size=2><b>Click Through Ratio</b></font></td><td width="60%" align="right"><font size=2>$genrat</font></td></tr>
<tr><td colspan=2><font color=red size=1>global stats for <b>$data{name}</b></font></td></tr>
</table>
</td></tr>
~;
}
$timp=0 if ($timp eq "");
$tclc=0 if ($tclc eq "");
if ($timp!=0){$trat=$tclc/$timp;}
else {$trat=0;}
$trat=$trat*100;
$trat=substr($trat,0,5);
if ($creditsystem)
{
$result.=qq~
<tr><td width="450">
<font size=5 color="#00B0B0">UNUSED CREDITS</font>
<table border="0" width="100%" cellpadding="0" bgcolor="#E0E0E0">
<tr><td width="40%" valign="top"><font size=2><b>Impressions</b></font></td><td width="60%" align="right"><font size=2>$impres</font></td></tr>
<tr><td width="40%" bgcolor="#C0C0C0" valign="top"><font size=2><b>Clicks</b></font></td><td width="60%" align="right" bgcolor="#C0C0C0"><font size=2>$cli</font></td></tr>
<tr><td colspan=2><font color=red size=1>global stats for <b>$data{name}</b></font></td></tr>
</table>
</td></tr>
~;
}
&closedb;
open (F,"<$adcpath/template/mgensts.tpl");
@htmlpage=<F>;
close (F);
$htmlpage=join("",@htmlpage);
$htmlpage="print qq~$htmlpage~;";
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $htmlpage;
exit;
}
sub admsub
{
$methods=qq~<option value=genset selected>General settings</option>
<option value=genstat>General stats</option>
<option value=usrman>Users management</option>
<option value=banman>Banners management</option>
<option value=user>Userlist</option>
<option value=html>HTML code</option>
<option value=systools>System tools</option>
~;
$methods.=qq~<option value=zone>Zone management</option>\n~ if ($zoneflag);
&closedb;
open (F,"<$adcpath/template/agenset.tpl");
@htmlpage=<F>;
close (F);
$htmlpage=join("",@htmlpage);
$htmlpage="print qq~$htmlpage~;";
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $htmlpage;
exit;
}
sub closedb
{
$sth="";
$dbh="";
}
