#!/usr/bin/perl
use Mysql;

#    ADCenter SQL v1.7 - ads management software
#    Copyright (C) 1998-2010  T&D Systems, Inc.
#    http://www.td-systems.com/
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.

######################################################################
# Variables Section                                                  #
######################################################################
# Reading variables from file
open (F, "<adc.cfg");
@commands=<F>;
close (F);
foreach (@commands)
{
	eval $_;
}
$dbh=Mysql->connect($mysqlhost,$mysqldb,$mysqllogin,$mysqlpassword);

######################################################################
# Main Section                                                       #
######################################################################
# Get data
if ($ENV{CONTENT_LENGTH}>0){sysread(STDIN,$data,$ENV{CONTENT_LENGTH});}
else {($data=$ENV{QUERY_STRING});}
@data=split("&",$data);
foreach (@data)
{
	/([^=]+)=(.*)/ && do
	{
		($field,$value)=($1,$2);
		$value=~s/\+/ /g;
		$value=~s/%([0-9a-fA-F]{2})/pack('C',hex($1))/eg;
		if ($data{$field}){$data{$field}="$data{$field},$value";}
		else {$data{$field}=$value;}
	}
}
$destination=$data{method};
$selected{$destination}="selected";
# Authorizing
$sth=$dbh->query("LOCK TABLES adc_users READ") if ($locktables);
$sth=$dbh->query("SELECT uid,icred,ccred FROM adc_users WHERE (username='$data{name}' AND password='$data{password}')");
($uid,$impres,$cli)=$sth->fetchrow;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
unless ($uid)
{
	&closedb;
	open (F,"<$adcpath/template/errauth.tpl");
	@htmlpage=<F>;
	close (F);
	$htmlpage=join("",@htmlpage);
	$htmlpage="print qq~$htmlpage~;";
	print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
	print "content-type: text/html\n\n";
	eval $htmlpage;
	exit;
}
&$destination;

######################################################################
# Subrotines Section                                                 #
######################################################################
sub genstats
{
$sth=$dbh->query("LOCK TABLES adc_banners READ") if ($locktables);
$sth=$dbh->query("SELECT bid,urltb,bcode FROM adc_banners WHERE uid=$uid");
while(($bid,$urltb,$bcode)=$sth->fetchrow)
{
	push(@bid,$bid);
	$urltb[$bid]=$urltb;
	$bcode[$bid]=$bcode;
}
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
foreach $ban(@bid)
{
@genimp=();
@genclc=();
$genimp=0;
$genclc=0;
if ($bcode[$ban])
{
	$bv="<center>$bcode[$ban]</center>";
}
elsif ($urltb[$ban])
{
	$bv="<center><img src=\"$urltb[$ban]\"></center>";
}
else
{
	if (-e "$adcpath/banners/$ban.gif")
	{
		$bv="<center><img src=\"$adcenter/banners/$ban.gif\"></center>";
	}
	else
	{
		$bv="<center><img src=\"$adcenter/banners/$ban.jpg\"></center>";
	}
}
$sth=$dbh->query("LOCK TABLES adc_imp READ") if ($locktables);
$sth=$dbh->query("SELECT SUM(adc_imp.h00),SUM(adc_imp.h01),SUM(adc_imp.h02),SUM(adc_imp.h03),SUM(adc_imp.h04),SUM(adc_imp.h05),SUM(adc_imp.h06),SUM(adc_imp.h07),SUM(adc_imp.h08),SUM(adc_imp.h09),SUM(adc_imp.h10),SUM(adc_imp.h11),SUM(adc_imp.h12),SUM(adc_imp.h13),SUM(adc_imp.h14),SUM(adc_imp.h15),SUM(adc_imp.h16),SUM(adc_imp.h17),SUM(adc_imp.h18),SUM(adc_imp.h19),SUM(adc_imp.h20),SUM(adc_imp.h21),SUM(adc_imp.h22),SUM(adc_imp.h23) FROM adc_imp WHERE (uid=$uid AND bid=$ban)");
@genimp=$sth->fetchrow;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
foreach(@genimp){$genimp+=$_;}
$timp+=$genimp;
$sth=$dbh->query("LOCK TABLES adc_clc READ") if ($locktables);
$sth=$dbh->query("SELECT SUM(adc_clc.h00),SUM(adc_clc.h01),SUM(adc_clc.h02),SUM(adc_clc.h03),SUM(adc_clc.h04),SUM(adc_clc.h05),SUM(adc_clc.h06),SUM(adc_clc.h07),SUM(adc_clc.h08),SUM(adc_clc.h09),SUM(adc_clc.h10),SUM(adc_clc.h11),SUM(adc_clc.h12),SUM(adc_clc.h13),SUM(adc_clc.h14),SUM(adc_clc.h15),SUM(adc_clc.h16),SUM(adc_clc.h17),SUM(adc_clc.h18),SUM(adc_clc.h19),SUM(adc_clc.h20),SUM(adc_clc.h21),SUM(adc_clc.h22),SUM(adc_clc.h23) FROM adc_clc WHERE (uid=$uid AND bid=$ban)");
@genclc=$sth->fetchrow;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
foreach(@genclc){$genclc+=$_;}
$tclc+=$genclc;
if ($genimp!=0){$genrat=$genclc/$genimp;}
else {$genrat=0;}
$genrat=$genrat*100;
$genrat=substr($genrat,0,5);
$result.=qq~
<tr><td width="450">
$bv
<table border="0" width="100%" cellpadding="0" bgcolor="#E0E0E0">
<tr><td width="40%" valign="top"><font size=2><b>Impressions</b></font></td><td width="60%" align="right"><font size=2>$genimp</font></td></tr>
<tr><td width="40%" bgcolor="#C0C0C0" valign="top"><font size=2><b>Clicks</b></font></td><td width="60%" align="right" bgcolor="#C0C0C0"><font size=2>$genclc</font></td></tr>
<tr><td width="40%" valign="top"><font size=2><b>Click Through Ratio</b></font></td><td width="60%" align="right"><font size=2>$genrat</font></td></tr>
<tr><td colspan=2><font color=red size=1>global stats for <b>$data{name}</b></font></td></tr>
</table>
</td></tr>
~;
}
$timp=0 if ($timp eq "");
$tclc=0 if ($tclc eq "");
if ($timp!=0){$trat=$tclc/$timp;}
else {$trat=0;}
$trat=$trat*100;
$trat=substr($trat,0,5);
if ($creditsystem)
{
$result.=qq~
<tr><td width="450">
<font size=5 color="#00B0B0">UNUSED CREDITS</font>
<table border="0" width="100%" cellpadding="0" bgcolor="#E0E0E0">
<tr><td width="40%" valign="top"><font size=2><b>Impressions</b></font></td><td width="60%" align="right"><font size=2>$impres</font></td></tr>
<tr><td width="40%" bgcolor="#C0C0C0" valign="top"><font size=2><b>Clicks</b></font></td><td width="60%" align="right" bgcolor="#C0C0C0"><font size=2>$cli</font></td></tr>
<tr><td colspan=2><font color=red size=1>global stats for <b>$data{name}</b></font></td></tr>
</table>
</td></tr>
~;
}
&closedb;
open (F,"<$adcpath/template/mgensts.tpl");
@htmlpage=<F>;
close (F);
$htmlpage=join("",@htmlpage);
$htmlpage="print qq~$htmlpage~;";
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $htmlpage;
exit;
}
sub hourstats
{
($ldate=scalar localtime)=~s/ \d+:\d+:\d+//;
($day,$month,$date,$time,$year)=split(" ",scalar localtime);
($day,$dtmn,$dtdt,$time,$dtyr)=split(" ",scalar localtime);
unless ($data{date})
{
($day,$data{month},$data{date},$time,$data{year})=split(" ",scalar localtime);
}
$data{date}=~s/\D+//g;
$data{date}=1 if ($data{date} eq "" || $data{date}<0 || $data{date}>31);
$data{year}=~s/\D+//g;
$data{year}=$dtyr if ($data{year} eq "" || $data{year}<0);
($ldate=scalar gmtime(time+$gmtzone*3600))=~s/ \d+:\d+:\d+//;
$mns=$data{month};
$selected{$mns}="selected";
$mon=$cal{$mns};
$sth=$dbh->query("LOCK TABLES adc_banners READ") if ($locktables);
$sth=$dbh->query("SELECT bid,urltb,bcode FROM adc_banners WHERE uid=$uid");
while(($bid,$urltb,$bcode)=$sth->fetchrow)
{
	push(@bid,$bid);
	$urltb[$bid]=$urltb;
	$bcode[$bid]=$bcode;
}
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
foreach $ban(@bid)
{
@dimp=();
@dclc=();
$genimp=0;
$genclc=0;
if ($bcode[$ban])
{
	$bv="<center>$bcode[$ban]</center>";
}
elsif ($urltb[$ban])
{
	$bv="<center><img src=\"$urltb[$ban]\"></center>";
}
else
{
	if (-e "$adcpath/banners/$ban.gif")
	{
		$bv="<center><img src=\"$adcenter/banners/$ban.gif\"></center>";
	}
	else
	{
		$bv="<center><img src=\"$adcenter/banners/$ban.jpg\"></center>";
	}
}
$sth=$dbh->query("LOCK TABLES adc_imp READ") if ($locktables);
$sth=$dbh->query("SELECT SUM(adc_imp.h00),SUM(adc_imp.h01),SUM(adc_imp.h02),SUM(adc_imp.h03),SUM(adc_imp.h04),SUM(adc_imp.h05),SUM(adc_imp.h06),SUM(adc_imp.h07),SUM(adc_imp.h08),SUM(adc_imp.h09),SUM(adc_imp.h10),SUM(adc_imp.h11),SUM(adc_imp.h12),SUM(adc_imp.h13),SUM(adc_imp.h14),SUM(adc_imp.h15),SUM(adc_imp.h16),SUM(adc_imp.h17),SUM(adc_imp.h18),SUM(adc_imp.h19),SUM(adc_imp.h20),SUM(adc_imp.h21),SUM(adc_imp.h22),SUM(adc_imp.h23) FROM adc_imp WHERE (uid=$uid AND bid=$ban AND statd='$data{year}-$mon-$data{date}')");
@dimp=$sth->fetchrow;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
$i=0;
while($i<24){$timp[$i]+=$dimp[$i];$i++;}
$sth=$dbh->query("LOCK TABLES adc_clc READ") if ($locktables);
$sth=$dbh->query("SELECT SUM(adc_clc.h00),SUM(adc_clc.h01),SUM(adc_clc.h02),SUM(adc_clc.h03),SUM(adc_clc.h04),SUM(adc_clc.h05),SUM(adc_clc.h06),SUM(adc_clc.h07),SUM(adc_clc.h08),SUM(adc_clc.h09),SUM(adc_clc.h10),SUM(adc_clc.h11),SUM(adc_clc.h12),SUM(adc_clc.h13),SUM(adc_clc.h14),SUM(adc_clc.h15),SUM(adc_clc.h16),SUM(adc_clc.h17),SUM(adc_clc.h18),SUM(adc_clc.h19),SUM(adc_clc.h20),SUM(adc_clc.h21),SUM(adc_clc.h22),SUM(adc_clc.h23) FROM adc_clc WHERE (uid=$uid AND bid=$ban AND statd='$data{year}-$mon-$data{date}')");
@dclc=$sth->fetchrow;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
$i=0;
while($i<24){$tclc[$i]+=$dclc[$i];$i++;}
$totimp=0;
$totclc=0;
$i=0;
while ($i<24){$dimp[$i]=0 unless ($dimp[$i]);$totimp+=$dimp[$i];$i++;}
$i=0;
while ($i<24){$dclc[$i]=0 unless ($dclc[$i]);$totclc+=$dclc[$i];$i++;}
@mdimp=@dimp;
@mdimp=sort ({$b<=>$a} @mdimp);
$maximp=shift(@mdimp);
if ($maximp<=10){$item1=10;$item2=7.5;$item3=5;$item4=2.5;}
elsif ($maximp<=100){$item1=100;$item2=75;$item3=50;$item4=25;}
elsif ($maximp<=1000){$item1=1000;$item2=750;$item3=500;$item4=250;}
elsif ($maximp<=10000){$item1=10000;$item2=7500;$item3=5000;$item4=2500;}
elsif ($maximp<=100000){$item1=100000;$item2=75000;$item3=50000;$item4=25000;}
elsif ($maximp<=1000000){$item1=1000000;$item2=750000;$item3=500000;$item4=250000;}
$grat=$item1/100;
$result.=qq~
<tr><td width="450">
$bv
<div align=center><center><table width="346" bgcolor=white cellpadding=0 cellspacing=0>
<tr><td colspan=2><center><font face="Lucida Console" size=1 color=red><br>Total impressions today: $totimp </font><br><br></center></td><td width=60 rowspan=3>&nbsp;</td></tr>
<tr><td valign=top align=right width=60><font face="Lucida Console" size=1>$item1&nbsp;&nbsp;</font></td><td width=286 height=103 rowspan=4 background="$adcenter/images/sgrid.gif" valign="bottom">
~;
$i=0;
foreach(@dimp)
{
	$height=int($_/$grat);
	$result.=qq~<img src="$adcenter/images/sg1.gif" width=8 height=$height border=1 bordercolor=black>~;
	if ($i<23){$result.=qq~<img src="$adcenter/images/sdot.gif">~;}
	$i++;
}
$result.=qq~
</td></tr>
<tr><td valign=top align=right><font face="Lucida Console" size=1>$item2&nbsp;&nbsp;</font></td></tr>
<tr><td valign=top align=right><font face="Lucida Console" size=1>$item3&nbsp;&nbsp;</font></td></tr>
<tr><td valign=top align=right><font face="Lucida Console" size=1>$item4&nbsp;&nbsp;</font></td></tr>
<tr><td valign=top align=right><font face="Lucida Console" size=1>0&nbsp;&nbsp;</font></td><td><img src="$adcenter/images/timebar.gif"></td></tr>
</table></center></div>
~;
@mdclc=@dclc;
@mdclc=sort ({$b<=>$a} @mdclc);
$maxclc=shift(@mdclc);
if ($maxclc<=10){$item1=10;$item2=7.5;$item3=5;$item4=2.5;}
elsif ($maxclc<=100){$item1=100;$item2=75;$item3=50;$item4=25;}
elsif ($maxclc<=1000){$item1=1000;$item2=750;$item3=500;$item4=250;}
elsif ($maxclc<=10000){$item1=10000;$item2=7500;$item3=5000;$item4=2500;}
elsif ($maxclc<=100000){$item1=100000;$item2=75000;$item3=50000;$item4=25000;}
elsif ($maxclc<=1000000){$item1=1000000;$item2=750000;$item3=500000;$item4=250000;}
$grat=$item1/100;
$result.=qq~
<div align=center><center><table width="346" bgcolor=white cellpadding=0 cellspacing=0>
<tr><td colspan=2><center><font face="Lucida Console" size=1 color=red><br>Total clicks today: $totclc </font><br><br></center></td><td width=60 rowspan=3>&nbsp;</td></tr>
<tr><td valign=top align=right width=60><font face="Lucida Console" size=1>$item1&nbsp;&nbsp;</font></td><td width=286 height=103 rowspan=4 background="$adcenter/images/sgrid.gif" valign="bottom">
~;
$i=0;
foreach(@dclc)
{
	$height=int($_/$grat);
	$result.=qq~<img src="$adcenter/images/sg2.gif" width=8 height=$height border=1 bordercolor=black>~;
	if ($i<23){$result.=qq~<img src="$adcenter/images/sdot.gif">~;}
	$i++;
}
$result.=qq~
</td></tr>
<tr><td valign=top align=right><font face="Lucida Console" size=1>$item2&nbsp;&nbsp;</font></td></tr>
<tr><td valign=top align=right><font face="Lucida Console" size=1>$item3&nbsp;&nbsp;</font></td></tr>
<tr><td valign=top align=right><font face="Lucida Console" size=1>$item4&nbsp;&nbsp;</font></td></tr>
<tr><td valign=top align=right><font face="Lucida Console" size=1>0&nbsp;&nbsp;</font></td><td><img src="$adcenter/images/timebar.gif"></td></tr>
</table></center></div>
~;
$result.=qq~
<table border="0" width="100%" cellpadding="0" bgcolor="#E0E0E0">
<tr><td width="40%" valign="top"><font size=2><b>Time</b></font></td><td width="30%" align="right"><font size=2><b>Impressions</b></font></td><td width="30%" align="right"><font size=2><b>Clicks</b></font></td></tr>
<tr><td width="40%" bgcolor="#C0C0C0" valign="top"><font size=2><b>12:00am</b></font></td><td width="30%" align="right" bgcolor="#C0C0C0"><font size=2>$dimp[0]</font></td><td width="30%" align="right" bgcolor="#C0C0C0"><font size=2>$dclc[0]</font></td></tr>
<tr><td width="40%" bgcolor="#C0C0C0" valign="top"><font size=2><b>1:00am</b></font></td><td width="30%" align="right" bgcolor="#C0C0C0"><font size=2>$dimp[1]</font></td><td width="30%" align="right" bgcolor="#C0C0C0"><font size=2>$dclc[1]</font></td></tr>
<tr><td width="40%" bgcolor="#C0C0C0" valign="top"><font size=2><b>2:00am</b></font></td><td width="30%" align="right" bgcolor="#C0C0C0"><font size=2>$dimp[2]</font></td><td width="30%" align="right" bgcolor="#C0C0C0"><font size=2>$dclc[2]</font></td></tr>
<tr><td width="40%" bgcolor="#C0C0C0" valign="top"><font size=2><b>3:00am</b></font></td><td width="30%" align="right" bgcolor="#C0C0C0"><font size=2>$dimp[3]</font></td><td width="30%" align="right" bgcolor="#C0C0C0"><font size=2>$dclc[3]</font></td></tr>
<tr><td width="40%" bgcolor="#C0C0C0" valign="top"><font size=2><b>4:00am</b></font></td><td width="30%" align="right" bgcolor="#C0C0C0"><font size=2>$dimp[4]</font></td><td width="30%" align="right" bgcolor="#C0C0C0"><font size=2>$dclc[4]</font></td></tr>
<tr><td width="40%" bgcolor="#C0C0C0" valign="top"><font size=2><b>5:00am</b></font></td><td width="30%" align="right" bgcolor="#C0C0C0"><font size=2>$dimp[5]</font></td><td width="30%" align="right" bgcolor="#C0C0C0"><font size=2>$dclc[5]</font></td></tr>
<tr><td width="40%" bgcolor="#C0C0C0" valign="top"><font size=2><b>6:00am</b></font></td><td width="30%" align="right" bgcolor="#C0C0C0"><font size=2>$dimp[6]</font></td><td width="30%" align="right" bgcolor="#C0C0C0"><font size=2>$dclc[6]</font></td></tr>
<tr><td width="40%" bgcolor="#C0C0C0" valign="top"><font size=2><b>7:00am</b></font></td><td width="30%" align="right" bgcolor="#C0C0C0"><font size=2>$dimp[7]</font></td><td width="30%" align="right" bgcolor="#C0C0C0"><font size=2>$dclc[7]</font></td></tr>
<tr><td width="40%" bgcolor="#C0C0C0" valign="top"><font size=2><b>8:00am</b></font></td><td width="30%" align="right" bgcolor="#C0C0C0"><font size=2>$dimp[8]</font></td><td width="30%" align="right" bgcolor="#C0C0C0"><font size=2>$dclc[8]</font></td></tr>
<tr><td width="40%" bgcolor="#C0C0C0" valign="top"><font size=2><b>9:00am</b></font></td><td width="30%" align="right" bgcolor="#C0C0C0"><font size=2>$dimp[9]</font></td><td width="30%" align="right" bgcolor="#C0C0C0"><font size=2>$dclc[9]</font></td></tr>
<tr><td width="40%" bgcolor="#C0C0C0" valign="top"><font size=2><b>10:00am</b></font></td><td width="30%" align="right" bgcolor="#C0C0C0"><font size=2>$dimp[10]</font></td><td width="30%" align="right" bgcolor="#C0C0C0"><font size=2>$dclc[10]</font></td></tr>
<tr><td width="40%" bgcolor="#C0C0C0" valign="top"><font size=2><b>11:00am</b></font></td><td width="30%" align="right" bgcolor="#C0C0C0"><font size=2>$dimp[11]</font></td><td width="30%" align="right" bgcolor="#C0C0C0"><font size=2>$dclc[11]</font></td></tr>
<tr><td width="40%" bgcolor="#C0C0C0" valign="top"><font size=2><b>12:00pm</b></font></td><td width="30%" align="right" bgcolor="#C0C0C0"><font size=2>$dimp[12]</font></td><td width="30%" align="right" bgcolor="#C0C0C0"><font size=2>$dclc[12]</font></td></tr>
<tr><td width="40%" bgcolor="#C0C0C0" valign="top"><font size=2><b>1:00pm</b></font></td><td width="30%" align="right" bgcolor="#C0C0C0"><font size=2>$dimp[13]</font></td><td width="30%" align="right" bgcolor="#C0C0C0"><font size=2>$dclc[13]</font></td></tr>
<tr><td width="40%" bgcolor="#C0C0C0" valign="top"><font size=2><b>2:00pm</b></font></td><td width="30%" align="right" bgcolor="#C0C0C0"><font size=2>$dimp[14]</font></td><td width="30%" align="right" bgcolor="#C0C0C0"><font size=2>$dclc[14]</font></td></tr>
<tr><td width="40%" bgcolor="#C0C0C0" valign="top"><font size=2><b>3:00pm</b></font></td><td width="30%" align="right" bgcolor="#C0C0C0"><font size=2>$dimp[15]</font></td><td width="30%" align="right" bgcolor="#C0C0C0"><font size=2>$dclc[15]</font></td></tr>
<tr><td width="40%" bgcolor="#C0C0C0" valign="top"><font size=2><b>4:00pm</b></font></td><td width="30%" align="right" bgcolor="#C0C0C0"><font size=2>$dimp[16]</font></td><td width="30%" align="right" bgcolor="#C0C0C0"><font size=2>$dclc[16]</font></td></tr>
<tr><td width="40%" bgcolor="#C0C0C0" valign="top"><font size=2><b>5:00pm</b></font></td><td width="30%" align="right" bgcolor="#C0C0C0"><font size=2>$dimp[17]</font></td><td width="30%" align="right" bgcolor="#C0C0C0"><font size=2>$dclc[17]</font></td></tr>
<tr><td width="40%" bgcolor="#C0C0C0" valign="top"><font size=2><b>6:00pm</b></font></td><td width="30%" align="right" bgcolor="#C0C0C0"><font size=2>$dimp[18]</font></td><td width="30%" align="right" bgcolor="#C0C0C0"><font size=2>$dclc[18]</font></td></tr>
<tr><td width="40%" bgcolor="#C0C0C0" valign="top"><font size=2><b>7:00pm</b></font></td><td width="30%" align="right" bgcolor="#C0C0C0"><font size=2>$dimp[19]</font></td><td width="30%" align="right" bgcolor="#C0C0C0"><font size=2>$dclc[19]</font></td></tr>
<tr><td width="40%" bgcolor="#C0C0C0" valign="top"><font size=2><b>8:00pm</b></font></td><td width="30%" align="right" bgcolor="#C0C0C0"><font size=2>$dimp[20]</font></td><td width="30%" align="right" bgcolor="#C0C0C0"><font size=2>$dclc[20]</font></td></tr>
<tr><td width="40%" bgcolor="#C0C0C0" valign="top"><font size=2><b>9:00pm</b></font></td><td width="30%" align="right" bgcolor="#C0C0C0"><font size=2>$dimp[21]</font></td><td width="30%" align="right" bgcolor="#C0C0C0"><font size=2>$dclc[21]</font></td></tr>
<tr><td width="40%" bgcolor="#C0C0C0" valign="top"><font size=2><b>10:00pm</b></font></td><td width="30%" align="right" bgcolor="#C0C0C0"><font size=2>$dimp[22]</font></td><td width="30%" align="right" bgcolor="#C0C0C0"><font size=2>$dclc[22]</font></td></tr>
<tr><td width="40%" bgcolor="#C0C0C0" valign="top"><font size=2><b>11:00pm</b></font></td><td width="30%" align="right" bgcolor="#C0C0C0"><font size=2>$dimp[23]</font></td><td width="30%" align="right" bgcolor="#C0C0C0"><font size=2>$dclc[23]</font></td></tr>
<tr><td colspan=3><font color=red size=1>hourly stats for <b>$data{name}</b> ($data{date} $data{month} $data{year})</font></td></tr>
</table>
</td></tr>
~;
}
$totimp=0;
$totclc=0;
$i=0;
while($i<24){$timp[$i]=0 unless ($timp[$i]);$totimp+=$timp[$i];$tclc[$i]=0 unless ($tclc[$i]);$totclc+=$tclc[$i];$i++;}
@mdimp=@timp;
@mdimp=sort ({$b<=>$a} @mdimp);
$maximp=shift(@mdimp);
if ($maximp<=10){$item1=10;$item2=7.5;$item3=5;$item4=2.5;}
elsif ($maximp<=100){$item1=100;$item2=75;$item3=50;$item4=25;}
elsif ($maximp<=1000){$item1=1000;$item2=750;$item3=500;$item4=250;}
elsif ($maximp<=10000){$item1=10000;$item2=7500;$item3=5000;$item4=2500;}
elsif ($maximp<=100000){$item1=100000;$item2=75000;$item3=50000;$item4=25000;}
elsif ($maximp<=1000000){$item1=1000000;$item2=750000;$item3=500000;$item4=250000;}
$grat=$item1/100;
$preresult.=qq~
<div align=center><center><table width="346" bgcolor=white cellpadding=0 cellspacing=0>
<tr><td colspan=2><center><font face="Lucida Console" size=1 color=red><br>Total impressions today: $totimp </font><br><br></center></td><td width=60 rowspan=3>&nbsp;</td></tr>
<tr><td valign=top align=right width=60><font face="Lucida Console" size=1>$item1&nbsp;&nbsp;</font></td><td width=286 height=103 rowspan=4 background="$adcenter/images/sgrid.gif" valign="bottom">
~;
$i=0;
foreach(@timp)
{
	$height=int($_/$grat);
	$preresult.=qq~<img src="$adcenter/images/sg1.gif" width=8 height=$height border=1 bordercolor=black>~;
	if ($i<23){$preresult.=qq~<img src="$adcenter/images/sdot.gif">~;}
	$i++;
}
$preresult.=qq~
</td></tr>
<tr><td valign=top align=right><font face="Lucida Console" size=1>$item2&nbsp;&nbsp;</font></td></tr>
<tr><td valign=top align=right><font face="Lucida Console" size=1>$item3&nbsp;&nbsp;</font></td></tr>
<tr><td valign=top align=right><font face="Lucida Console" size=1>$item4&nbsp;&nbsp;</font></td></tr>
<tr><td valign=top align=right><font face="Lucida Console" size=1>0&nbsp;&nbsp;</font></td><td><img src="$adcenter/images/timebar.gif"></td></tr>
</table></center></div>
~;
@mdclc=@tclc;
@mdclc=sort ({$b<=>$a} @mdclc);
$maxclc=shift(@mdclc);
if ($maxclc<=10){$item1=10;$item2=7.5;$item3=5;$item4=2.5;}
elsif ($maxclc<=100){$item1=100;$item2=75;$item3=50;$item4=25;}
elsif ($maxclc<=1000){$item1=1000;$item2=750;$item3=500;$item4=250;}
elsif ($maxclc<=10000){$item1=10000;$item2=7500;$item3=5000;$item4=2500;}
elsif ($maxclc<=100000){$item1=100000;$item2=75000;$item3=50000;$item4=25000;}
elsif ($maxclc<=1000000){$item1=1000000;$item2=750000;$item3=500000;$item4=250000;}
$grat=$item1/100;
$preresult.=qq~
<div align=center><center><table width="346" bgcolor=white cellpadding=0 cellspacing=0>
<tr><td colspan=2><center><font face="Lucida Console" size=1 color=red><br>Total clicks today: $totclc </font><br><br></center></td><td width=60 rowspan=3>&nbsp;</td></tr>
<tr><td valign=top align=right width=60><font face="Lucida Console" size=1>$item1&nbsp;&nbsp;</font></td><td width=286 height=103 rowspan=4 background="$adcenter/images/sgrid.gif" valign="bottom">
~;
$i=0;
foreach(@tclc)
{
	$height=int($_/$grat);
	$preresult.=qq~<img src="$adcenter/images/sg2.gif" width=8 height=$height border=1 bordercolor=black>~;
	if ($i<23){$preresult.=qq~<img src="$adcenter/images/sdot.gif">~;}
	$i++;
}
$preresult.=qq~
</td></tr>
<tr><td valign=top align=right><font face="Lucida Console" size=1>$item2&nbsp;&nbsp;</font></td></tr>
<tr><td valign=top align=right><font face="Lucida Console" size=1>$item3&nbsp;&nbsp;</font></td></tr>
<tr><td valign=top align=right><font face="Lucida Console" size=1>$item4&nbsp;&nbsp;</font></td></tr>
<tr><td valign=top align=right><font face="Lucida Console" size=1>0&nbsp;&nbsp;</font></td><td><img src="$adcenter/images/timebar.gif"></td></tr>
</table></center></div>
~;
&closedb;
open (F,"<$adcpath/template/mhorsts.tpl");
@htmlpage=<F>;
close (F);
$htmlpage=join("",@htmlpage);
$htmlpage="print qq~$htmlpage~;";
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $htmlpage;
exit;
}
sub daystats
{
($ldate=scalar localtime)=~s/ \d+:\d+:\d+//;
($day,$month,$date,$time,$year)=split(" ",scalar localtime);
unless ($data{month})
{
($day,$data{month},$date,$time,$data{year})=split(" ",scalar localtime);
}
($day,$dtmn,$dtdt,$time,$dtyr)=split(" ",scalar localtime);
$data{year}=~s/\D+//g;
$data{year}=$dtyr if ($data{year} eq "" || $data{year}<0);
$month=$data{month};
$selected{$month}="selected";
$mon=$cal{$month};
$calendar{$month}=29 if ($year/4-int($year/4)==0 && $month eq "Feb");
$sth=$dbh->query("LOCK TABLES adc_banners READ") if ($locktables);
$sth=$dbh->query("SELECT bid,urltb,bcode FROM adc_banners WHERE uid=$uid");
while(($bid,$urltb,$bcode)=$sth->fetchrow)
{
	push(@bid,$bid);
	$urltb[$bid]=$urltb;
	$bcode[$bid]=$bcode;
}
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
foreach $ban(@bid)
{
@mimp=();
@mclc=();
@mstats=();
if ($bcode[$ban])
{
	$bv="<center>$bcode[$ban]</center>";
}
elsif ($urltb[$ban])
{
	$bv="<center><img src=\"$urltb[$ban]\"></center>";
}
else
{
	if (-e "$adcpath/banners/$ban.gif")
	{
		$bv="<center><img src=\"$adcenter/banners/$ban.gif\"></center>";
	}
	else
	{
		$bv="<center><img src=\"$adcenter/banners/$ban.jpg\"></center>";
	}
}
$sth=$dbh->query("LOCK TABLES adc_imp READ") if ($locktables);
$sth=$dbh->query("SELECT statd,adc_imp.h00,adc_imp.h01,adc_imp.h02,adc_imp.h03,adc_imp.h04,adc_imp.h05,adc_imp.h06,adc_imp.h07,adc_imp.h08,adc_imp.h09,adc_imp.h10,adc_imp.h11,adc_imp.h12,adc_imp.h13,adc_imp.h14,adc_imp.h15,adc_imp.h16,adc_imp.h17,adc_imp.h18,adc_imp.h19,adc_imp.h20,adc_imp.h21,adc_imp.h22,adc_imp.h23 FROM adc_imp WHERE (uid=$uid AND bid=$ban AND statd>='$data{year}-$mon-01' AND statd<='$data{year}-$mon-$calendar{$month}')");
while(($statd,@temp)=$sth->fetchrow)
{
	$temp=0;
	foreach(@temp){$temp+=$_;}
	($arg1,$arg2,$arg3)=split("-",$statd);
	$mimp[$arg3]+=$temp;$timp[$arg3]+=$temp;
	@temp=();
}
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
$sth=$dbh->query("LOCK TABLES adc_clc READ") if ($locktables);
$sth=$dbh->query("SELECT statd,adc_clc.h00,adc_clc.h01,adc_clc.h02,adc_clc.h03,adc_clc.h04,adc_clc.h05,adc_clc.h06,adc_clc.h07,adc_clc.h08,adc_clc.h09,adc_clc.h10,adc_clc.h11,adc_clc.h12,adc_clc.h13,adc_clc.h14,adc_clc.h15,adc_clc.h16,adc_clc.h17,adc_clc.h18,adc_clc.h19,adc_clc.h20,adc_clc.h21,adc_clc.h22,adc_clc.h23 FROM adc_clc WHERE (uid=$uid AND bid=$ban AND statd>='$data{year}-$mon-01' AND statd<='$data{year}-$mon-$calendar{$month}')");
while(($statd,@temp)=$sth->fetchrow)
{
	$temp=0;
	foreach(@temp){$temp+=$_;}
	($arg1,$arg2,$arg3)=split("-",$statd);
	$mclc[$arg3]+=$temp;$tclc[$arg3]+=$temp;
	@temp=();
}
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
$i=1;
$calendar{$month}=29 if ($year/4-int($year/4)==0 && $month eq "Feb");
$tablewidth=12*$calendar{$month}-2;
$table=$tablewidth+60;
$totimp=0;
$totclc=0;
while($i<$calendar{$month}+1)
{
	$mclc[$i]=0 if ($mclc[$i] eq "");
	$mimp[$i]=0 if ($mimp[$i] eq "");
	$totimp+=$mimp[$i];
	$totclc+=$mclc[$i];
	push(@mstats,"<tr><td bgcolor=\"#C0C0C0\"><font size=2><b>$i</b></font></td><td align=\"right\" bgcolor=\"#C0C0C0\"><font size=2>$mimp[$i]</font></td><td align=\"right\" bgcolor=\"#C0C0C0\"><font size=2>$mclc[$i]</font></td></tr>\n");
	$i++;
}
@mmimp=@mimp;
@mmimp=sort ({$b<=>$a} @mmimp);
$maximp=shift(@mmimp);
if ($maximp<=10){$item1=10;$item2=7.5;$item3=5;$item4=2.5;}
elsif ($maximp<=100){$item1=100;$item2=75;$item3=50;$item4=25;}
elsif ($maximp<=1000){$item1=1000;$item2=750;$item3=500;$item4=250;}
elsif ($maximp<=10000){$item1=10000;$item2=7500;$item3=5000;$item4=2500;}
elsif ($maximp<=100000){$item1=100000;$item2=75000;$item3=50000;$item4=25000;}
elsif ($maximp<=1000000){$item1=1000000;$item2=750000;$item3=500000;$item4=250000;}
$grat=$item1/100;
$result.=qq~
<tr><td width="450">
$bv
<div align=center><center><table width=$table bgcolor=white cellpadding=0 cellspacing=0>
<tr><td colspan=2><center><font face="Lucida Console" size=1 color=red><br>Total impressions in this month: $totimp </font><br><br></center></td><td width=60 rowspan=3>&nbsp;</td></tr>
<tr><td valign=top align=right width=60><font face="Lucida Console" size=1>$item1&nbsp;&nbsp;</font></td><td width=$tablewidth height=103 rowspan=4 background="$adcenter/images/sgrid.gif" valign="bottom">
~;
$i=1;
while($i<$calendar{$month}+1)
{
	$height=int($mimp[$i]/$grat);
	$result.=qq~<img src="$adcenter/images/sg1.gif" width=8 height=$height border=1 bordercolor=black>~;
	if ($i<$calendar{$month}){$result.=qq~<img src="$adcenter/images/sdot.gif">~;}
	$i++;
}
$result.=qq~
</td></tr>
<tr><td valign=top align=right><font face="Lucida Console" size=1>$item2&nbsp;&nbsp;</font></td></tr>
<tr><td valign=top align=right><font face="Lucida Console" size=1>$item3&nbsp;&nbsp;</font></td></tr>
<tr><td valign=top align=right><font face="Lucida Console" size=1>$item4&nbsp;&nbsp;</font></td></tr>
<tr><td valign=top align=right><font face="Lucida Console" size=1>0&nbsp;&nbsp;</font></td><td><img src="$adcenter/images/daybar$calendar{$month}.gif"></td></tr>
</table></center></div>
~;
@mmclc=@mclc;
@mmclc=sort ({$b<=>$a} @mmclc);
$maxclc=shift(@mmclc);
if ($maxclc<=10){$item1=10;$item2=7.5;$item3=5;$item4=2.5;}
elsif ($maxclc<=100){$item1=100;$item2=75;$item3=50;$item4=25;}
elsif ($maxclc<=1000){$item1=1000;$item2=750;$item3=500;$item4=250;}
elsif ($maxclc<=10000){$item1=10000;$item2=7500;$item3=5000;$item4=2500;}
elsif ($maxclc<=100000){$item1=100000;$item2=75000;$item3=50000;$item4=25000;}
elsif ($maxclc<=1000000){$item1=1000000;$item2=750000;$item3=500000;$item4=250000;}
$grat=$item1/100;
$result.=qq~
<div align=center><center><table width=$table bgcolor=white cellpadding=0 cellspacing=0>
<tr><td colspan=2><center><font face="Lucida Console" size=1 color=red><br>Total clicks in this month: $totclc </font><br><br></center></td><td width=60 rowspan=3>&nbsp;</td></tr>
<tr><td valign=top align=right width=60><font face="Lucida Console" size=1>$item1&nbsp;&nbsp;</font></td><td width=$tablewidth height=103 rowspan=4 background="$adcenter/images/sgrid.gif" valign="bottom">
~;
$i=1;
while($i<$calendar{$month}+1)
{
	$height=int($mclc[$i]/$grat);
	$result.=qq~<img src="$adcenter/images/sg2.gif" width=8 height=$height border=1 bordercolor=black>~;
	if ($i<$calendar{$month}){$result.=qq~<img src="$adcenter/images/sdot.gif">~;}
	$i++;
}
$result.=qq~
</td></tr>
<tr><td valign=top align=right><font face="Lucida Console" size=1>$item2&nbsp;&nbsp;</font></td></tr>
<tr><td valign=top align=right><font face="Lucida Console" size=1>$item3&nbsp;&nbsp;</font></td></tr>
<tr><td valign=top align=right><font face="Lucida Console" size=1>$item4&nbsp;&nbsp;</font></td></tr>
<tr><td valign=top align=right><font face="Lucida Console" size=1>0&nbsp;&nbsp;</font></td><td><img src="$adcenter/images/daybar$calendar{$month}.gif"></td></tr>
</table></center></div>
~;
$result.=qq~
<table border="0" width="100%" cellpadding="0" bgcolor="#E0E0E0">
<tr><td width="40%" valign="top"><font size=2><b>Date</b></font></td><td width="30%" align="right"><font size=2><b>Impressions</b></font></td><td width="30%" align="right"><font size=2><b>Clicks</b></font></td></tr>
@mstats
<tr><td colspan=3><font color=red size=1>daily stats for <b>$data{name}</b> ($month $data{year})</font></td></tr>
</table>
</td></tr>
~;
}
@mstats=();
$calendar{$month}=29 if ($year/4-int($year/4)==0 && $month eq "Feb");
$tablewidth=12*$calendar{$month}-2;
$table=$tablewidth+60;
$totimp=0;
$totclc=0;
$i=1;
while($i<$calendar{$month}+1)
{
	$tclc[$i]=0 if ($tclc[$i] eq "");
	$timp[$i]=0 if ($timp[$i] eq "");
	$totimp+=$timp[$i];
	$totclc+=$tclc[$i];
	push(@mstats,"<tr><td bgcolor=\"#C0C0C0\"><font size=2><b>$i</b></font></td><td align=\"right\" bgcolor=\"#C0C0C0\"><font size=2>$timp[$i]</font></td><td align=\"right\" bgcolor=\"#C0C0C0\"><font size=2>$tclc[$i]</font></td></tr>\n");
	$i++;
}
@mmimp=@timp;
@mmimp=sort ({$b<=>$a} @mmimp);
$maximp=shift(@mmimp);
if ($maximp<=10){$item1=10;$item2=7.5;$item3=5;$item4=2.5;}
elsif ($maximp<=100){$item1=100;$item2=75;$item3=50;$item4=25;}
elsif ($maximp<=1000){$item1=1000;$item2=750;$item3=500;$item4=250;}
elsif ($maximp<=10000){$item1=10000;$item2=7500;$item3=5000;$item4=2500;}
elsif ($maximp<=100000){$item1=100000;$item2=75000;$item3=50000;$item4=25000;}
elsif ($maximp<=1000000){$item1=1000000;$item2=750000;$item3=500000;$item4=250000;}
$grat=$item1/100;
$preresult.=qq~
<div align=center><center><table width=$table bgcolor=white cellpadding=0 cellspacing=0>
<tr><td colspan=2><center><font face="Lucida Console" size=1 color=red><br>Total impressions in this month: $totimp </font><br><br></center></td><td width=60 rowspan=3>&nbsp;</td></tr>
<tr><td valign=top align=right width=60><font face="Lucida Console" size=1>$item1&nbsp;&nbsp;</font></td><td width=$tablewidth height=103 rowspan=4 background="$adcenter/images/sgrid.gif" valign="bottom">
~;
$i=1;
while($i<$calendar{$month}+1)
{
	$height=int($timp[$i]/$grat);
	$preresult.=qq~<img src="$adcenter/images/sg1.gif" width=8 height=$height border=1 bordercolor=black>~;
	if ($i<$calendar{$month}){$preresult.=qq~<img src="$adcenter/images/sdot.gif">~;}
	$i++;
}
$preresult.=qq~
</td></tr>
<tr><td valign=top align=right><font face="Lucida Console" size=1>$item2&nbsp;&nbsp;</font></td></tr>
<tr><td valign=top align=right><font face="Lucida Console" size=1>$item3&nbsp;&nbsp;</font></td></tr>
<tr><td valign=top align=right><font face="Lucida Console" size=1>$item4&nbsp;&nbsp;</font></td></tr>
<tr><td valign=top align=right><font face="Lucida Console" size=1>0&nbsp;&nbsp;</font></td><td><img src="$adcenter/images/daybar$calendar{$month}.gif"></td></tr>
</table></center></div>
~;
@mmclc=@tclc;
@mmclc=sort ({$b<=>$a} @mmclc);
$maxclc=shift(@mmclc);
if ($maxclc<=10){$item1=10;$item2=7.5;$item3=5;$item4=2.5;}
elsif ($maxclc<=100){$item1=100;$item2=75;$item3=50;$item4=25;}
elsif ($maxclc<=1000){$item1=1000;$item2=750;$item3=500;$item4=250;}
elsif ($maxclc<=10000){$item1=10000;$item2=7500;$item3=5000;$item4=2500;}
elsif ($maxclc<=100000){$item1=100000;$item2=75000;$item3=50000;$item4=25000;}
elsif ($maxclc<=1000000){$item1=1000000;$item2=750000;$item3=500000;$item4=250000;}
$grat=$item1/100;
$preresult.=qq~
<div align=center><center><table width=$table bgcolor=white cellpadding=0 cellspacing=0>
<tr><td colspan=2><center><font face="Lucida Console" size=1 color=red><br>Total clicks in this month: $totclc </font><br><br></center></td><td width=60 rowspan=3>&nbsp;</td></tr>
<tr><td valign=top align=right width=60><font face="Lucida Console" size=1>$item1&nbsp;&nbsp;</font></td><td width=$tablewidth height=103 rowspan=4 background="$adcenter/images/sgrid.gif" valign="bottom">
~;
$i=1;
while($i<$calendar{$month}+1)
{
	$height=int($tclc[$i]/$grat);
	$preresult.=qq~<img src="$adcenter/images/sg2.gif" width=8 height=$height border=1 bordercolor=black>~;
	if ($i<$calendar{$month}){$preresult.=qq~<img src="$adcenter/images/sdot.gif">~;}
	$i++;
}
$preresult.=qq~
</td></tr>
<tr><td valign=top align=right><font face="Lucida Console" size=1>$item2&nbsp;&nbsp;</font></td></tr>
<tr><td valign=top align=right><font face="Lucida Console" size=1>$item3&nbsp;&nbsp;</font></td></tr>
<tr><td valign=top align=right><font face="Lucida Console" size=1>$item4&nbsp;&nbsp;</font></td></tr>
<tr><td valign=top align=right><font face="Lucida Console" size=1>0&nbsp;&nbsp;</font></td><td><img src="$adcenter/images/daybar$calendar{$month}.gif"></td></tr>
</table></center></div>
~;
&closedb;
open (F,"<$adcpath/template/mdaysts.tpl");
@htmlpage=<F>;
close (F);
$htmlpage=join("",@htmlpage);
$htmlpage="print qq~$htmlpage~;";
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $htmlpage;
exit;
}
sub monstats
{
($ldate=scalar localtime)=~s/ \d+:\d+:\d+//;
unless ($data{year})
{
($day,$month,$date,$time,$data{year})=split(" ",scalar localtime);
}
($day,$dtmn,$dtdt,$time,$dtyr)=split(" ",scalar localtime);
$data{year}=~s/\D+//g;
$data{year}=$dtyr if ($data{year} eq "" || $data{year}<0);
$sth=$dbh->query("LOCK TABLES adc_banners READ") if ($locktables);
$sth=$dbh->query("SELECT bid,urltb,bcode FROM adc_banners WHERE uid=$uid");
while(($bid,$urltb,$bcode)=$sth->fetchrow)
{
	push(@bid,$bid);
	$urltb[$bid]=$urltb;
	$bcode[$bid]=$bcode;
}
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
foreach $ban(@bid)
{
@mimp=();
@mclc=();
@mstats=();
$totimp=0;
$totclc=0;
if ($bcode[$ban])
{
	$bv="<center>$bcode[$ban]</center>";
}
elsif ($urltb[$ban])
{
	$bv="<center><img src=\"$urltb[$ban]\"></center>";
}
else
{
	if (-e "$adcpath/banners/$ban.gif")
	{
		$bv="<center><img src=\"$adcenter/banners/$ban.gif\"></center>";
	}
	else
	{
		$bv="<center><img src=\"$adcenter/banners/$ban.jpg\"></center>";
	}
}
$sth=$dbh->query("LOCK TABLES adc_imp READ") if ($locktables);
$sth=$dbh->query("SELECT statd,adc_imp.h00,adc_imp.h01,adc_imp.h02,adc_imp.h03,adc_imp.h04,adc_imp.h05,adc_imp.h06,adc_imp.h07,adc_imp.h08,adc_imp.h09,adc_imp.h10,adc_imp.h11,adc_imp.h12,adc_imp.h13,adc_imp.h14,adc_imp.h15,adc_imp.h16,adc_imp.h17,adc_imp.h18,adc_imp.h19,adc_imp.h20,adc_imp.h21,adc_imp.h22,adc_imp.h23 FROM adc_imp WHERE (uid=$uid AND bid=$ban AND statd>='$data{year}-01-01' AND statd<='$data{year}-12-31')");
while(($statd,@temp)=$sth->fetchrow)
{
	$temp=0;
	foreach(@temp){$temp+=$_;}
	($arg1,$arg2,$arg3)=split("-",$statd);
	$mimp[$arg2]+=$temp;$timp[$arg2]+=$temp;
	@temp=();
}
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
$sth=$dbh->query("LOCK TABLES adc_clc READ") if ($locktables);
$sth=$dbh->query("SELECT statd,adc_clc.h00,adc_clc.h01,adc_clc.h02,adc_clc.h03,adc_clc.h04,adc_clc.h05,adc_clc.h06,adc_clc.h07,adc_clc.h08,adc_clc.h09,adc_clc.h10,adc_clc.h11,adc_clc.h12,adc_clc.h13,adc_clc.h14,adc_clc.h15,adc_clc.h16,adc_clc.h17,adc_clc.h18,adc_clc.h19,adc_clc.h20,adc_clc.h21,adc_clc.h22,adc_clc.h23 FROM adc_clc WHERE (uid=$uid AND bid=$ban AND statd>='$data{year}-01-01' AND statd<='$data{year}-12-31')");
while(($statd,@temp)=$sth->fetchrow)
{
	$temp=0;
	foreach(@temp){$temp+=$_;}
	($arg1,$arg2,$arg3)=split("-",$statd);
	$mclc[$arg2]+=$temp;$tclc[$arg2]+=$temp;
	@temp=();
}
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
$tablewidth=12*12-2;
$table=$tablewidth+60;
foreach(@cal)
{
	$temp=$cal{$_};
	$mimp[$temp]=0 if ($mimp[$temp] eq "");
	$mclc[$temp]=0 if ($mclc[$temp] eq "");
}
$totimp=0 if (!$totimp);
$totclc=0 if (!$totclc);
$result.=qq~<tr><td width="450" colspan=2>
$bv
</td></tr>
<tr><td width="30%">
<div align=center><center><table width=$table bgcolor=white cellpadding=0 cellspacing=0 border=1><tr><td><table width=$table bgcolor=white cellpadding=0 cellspacing=0 border=0>
<tr><td colspan=2><center><font face="Lucida Console" size=1 color=red><br>Total impressions for $data{year}: $totimp </font><br><br></center></td><td width=60 rowspan=3>&nbsp;</td></tr>
<tr><td valign=top align=right width=60><font face="Lucida Console" size=1>$item1&nbsp;&nbsp;</font></td><td width=$tablewidth height=103 rowspan=4 background="$adcenter/images/sgrid.gif" valign="bottom">
~;
@mmimp=@mimp;
@mmimp=sort ({$b<=>$a} @mmimp);
$maximp=shift(@mmimp);
if ($maximp<=10){$item1=10;$item2=7.5;$item3=5;$item4=2.5;}
elsif ($maximp<=100){$item1=100;$item2=75;$item3=50;$item4=25;}
elsif ($maximp<=1000){$item1=1000;$item2=750;$item3=500;$item4=250;}
elsif ($maximp<=10000){$item1=10000;$item2=7500;$item3=5000;$item4=2500;}
elsif ($maximp<=100000){$item1=100000;$item2=75000;$item3=50000;$item4=25000;}
elsif ($maximp<=1000000){$item1=1000000;$item2=750000;$item3=500000;$item4=250000;}
$grat=$item1/100;
$i=1;
while($i<13)
{
	$height=int($mimp[$i]/$grat);
	$result.=qq~<img src="$adcenter/images/sg1.gif" width=8 height=$height border=1 bordercolor=black>~;
	if ($i<12){$result.=qq~<img src="$adcenter/images/sdot.gif">~;}
	$i++;
}
@mmclc=@mclc;
@mmclc=sort ({$b<=>$a} @mmclc);
$maxclc=shift(@mmclc);
if ($maxclc<=10){$itm1=10;$itm2=7.5;$itm3=5;$itm4=2.5;}
elsif ($maxclc<=100){$itm1=100;$itm2=75;$itm3=50;$itm4=25;}
elsif ($maxclc<=1000){$itm1=1000;$itm2=750;$itm3=500;$itm4=250;}
elsif ($maxclc<=10000){$itm1=10000;$itm2=7500;$itm3=5000;$itm4=2500;}
elsif ($maxclc<=100000){$itm1=100000;$itm2=75000;$itm3=50000;$itm4=25000;}
elsif ($maxclc<=1000000){$itm1=1000000;$itm2=750000;$itm3=500000;$itm4=250000;}
$grat=$itm1/100;
$result.=qq~</td></tr>
<tr><td valign=top align=right><font face="Lucida Console" size=1>$item2&nbsp;&nbsp;</font></td></tr>
<tr><td valign=top align=right><font face="Lucida Console" size=1>$item3&nbsp;&nbsp;</font></td></tr>
<tr><td valign=top align=right><font face="Lucida Console" size=1>$item4&nbsp;&nbsp;</font></td></tr>
<tr><td valign=top align=right><font face="Lucida Console" size=1>0&nbsp;&nbsp;</font></td><td><img src="$adcenter/images/monbar.gif"></td></tr>
</table></td></tr></table></center></div>
<div align=center><center><table width=$table bgcolor=white cellpadding=0 cellspacing=0 border=1><tr><td><table width=$table bgcolor=white cellpadding=0 cellspacing=0>
<tr><td colspan=2><center><font face="Lucida Console" size=1 color=red><br>Total clicks for $data{year}: $totclc </font><br><br></center></td><td width=60 rowspan=3>&nbsp;</td></tr>
<tr><td valign=top align=right width=60><font face="Lucida Console" size=1>$itm1&nbsp;&nbsp;</font></td><td width=$tablewidth height=103 rowspan=4 background="$adcenter/images/sgrid.gif" valign="bottom">~;
$i=1;
while($i<13)
{
	$height=int($mclc[$i]/$grat);
	$result.=qq~<img src="$adcenter/images/sg2.gif" width=8 height=$height border=1 bordercolor=black>~;
	if ($i<12){$result.=qq~<img src="$adcenter/images/sdot.gif">~;}
	$i++;
}
$result.=qq~
</td></tr>
<tr><td valign=top align=right><font face="Lucida Console" size=1>$itm2&nbsp;&nbsp;</font></td></tr>
<tr><td valign=top align=right><font face="Lucida Console" size=1>$itm3&nbsp;&nbsp;</font></td></tr>
<tr><td valign=top align=right><font face="Lucida Console" size=1>$itm4&nbsp;&nbsp;</font></td></tr>
<tr><td valign=top align=right><font face="Lucida Console" size=1>0&nbsp;&nbsp;</font></td><td><img src="$adcenter/images/monbar.gif"></td></tr>
</table></td></tr></table></center></div>
</td><td width="70%" valign=top>
<table border="0" width="100%" cellpadding="0" bgcolor="#E0E0E0">
<tr><td width="60%" valign="top"><font size=2><b>Month</b></font></td><td width="20%" align="right"><font size=2><b>Impressions</b></font></td><td width="20%" align="right"><font size=2><b>Clicks</b></font></td></tr>
<tr><td bgcolor="#C0C0C0"><font size=2><b>January</b></font></td><td align="right" bgcolor="#C0C0C0"><font size=2>$mimp[1]</font></td><td align="right" bgcolor="#C0C0C0"><font size=2>$mclc[1]</font></td></tr>
<tr><td bgcolor="#C0C0C0"><font size=2><b>February</b></font></td><td align="right" bgcolor="#C0C0C0"><font size=2>$mimp[2]</font></td><td align="right" bgcolor="#C0C0C0"><font size=2>$mclc[2]</font></td></tr>
<tr><td bgcolor="#C0C0C0"><font size=2><b>March</b></font></td><td align="right" bgcolor="#C0C0C0"><font size=2>$mimp[3]</font></td><td align="right" bgcolor="#C0C0C0"><font size=2>$mclc[3]</font></td></tr>
<tr><td bgcolor="#C0C0C0"><font size=2><b>April</b></font></td><td align="right" bgcolor="#C0C0C0"><font size=2>$mimp[4]</font></td><td align="right" bgcolor="#C0C0C0"><font size=2>$mclc[4]</font></td></tr>
<tr><td bgcolor="#C0C0C0"><font size=2><b>May</b></font></td><td align="right" bgcolor="#C0C0C0"><font size=2>$mimp[5]</font></td><td align="right" bgcolor="#C0C0C0"><font size=2>$mclc[5]</font></td></tr>
<tr><td bgcolor="#C0C0C0"><font size=2><b>June</b></font></td><td align="right" bgcolor="#C0C0C0"><font size=2>$mimp[6]</font></td><td align="right" bgcolor="#C0C0C0"><font size=2>$mclc[6]</font></td></tr>
<tr><td bgcolor="#C0C0C0"><font size=2><b>July</b></font></td><td align="right" bgcolor="#C0C0C0"><font size=2>$mimp[7]</font></td><td align="right" bgcolor="#C0C0C0"><font size=2>$mclc[7]</font></td></tr>
<tr><td bgcolor="#C0C0C0"><font size=2><b>August</b></font></td><td align="right" bgcolor="#C0C0C0"><font size=2>$mimp[8]</font></td><td align="right" bgcolor="#C0C0C0"><font size=2>$mclc[8]</font></td></tr>
<tr><td bgcolor="#C0C0C0"><font size=2><b>September</b></font></td><td align="right" bgcolor="#C0C0C0"><font size=2>$mimp[9]</font></td><td align="right" bgcolor="#C0C0C0"><font size=2>$mclc[9]</font></td></tr>
<tr><td bgcolor="#C0C0C0"><font size=2><b>October</b></font></td><td align="right" bgcolor="#C0C0C0"><font size=2>$mimp[10]</font></td><td align="right" bgcolor="#C0C0C0"><font size=2>$mclc[10]</font></td></tr>
<tr><td bgcolor="#C0C0C0"><font size=2><b>November</b></font></td><td align="right" bgcolor="#C0C0C0"><font size=2>$mimp[11]</font></td><td align="right" bgcolor="#C0C0C0"><font size=2>$mclc[11]</font></td></tr>
<tr><td bgcolor="#C0C0C0"><font size=2><b>December</b></font></td><td align="right" bgcolor="#C0C0C0"><font size=2>$mimp[12]</font></td><td align="right" bgcolor="#C0C0C0"><font size=2>$mclc[12]</font></td></tr>
<tr><td colspan=3><font color=red size=1>Monthly stats for <b>$data{name}</b> ($data{year})</font></td></tr>
</table>
</td></tr>
~;
}
$totimp=0;
$totclc=0;
$tablewidth=12*12-2;
$table=$tablewidth+60;
foreach(@cal)
{
	$temp=$cal{$_};
	$timp[$temp]=0 if ($timp[$temp] eq "");
	$tclc[$temp]=0 if ($tclc[$temp] eq "");
	$totclc+=$tclc[$temp];
	$totimp+=$timp[$temp];
}
@mmimp=@timp;
@mmimp=sort ({$b<=>$a} @mmimp);
$maximp=shift(@mmimp);
if ($maximp<=10){$item1=10;$item2=7.5;$item3=5;$item4=2.5;}
elsif ($maximp<=100){$item1=100;$item2=75;$item3=50;$item4=25;}
elsif ($maximp<=1000){$item1=1000;$item2=750;$item3=500;$item4=250;}
elsif ($maximp<=10000){$item1=10000;$item2=7500;$item3=5000;$item4=2500;}
elsif ($maximp<=100000){$item1=100000;$item2=75000;$item3=50000;$item4=25000;}
elsif ($maximp<=1000000){$item1=1000000;$item2=750000;$item3=500000;$item4=250000;}
$grat=$item1/100;
$i=1;
$preresult.=qq~<div align=center><center><table width=$table bgcolor=white cellpadding=0 cellspacing=0 border=1><tr><td><table width=$table bgcolor=white cellpadding=0 cellspacing=0 border=0>
<tr><td colspan=2><center><font face="Lucida Console" size=1 color=red><br>Total impressions for $data{year}: $totimp </font><br><br></center></td><td width=60 rowspan=3>&nbsp;</td></tr>
<tr><td valign=top align=right width=60><font face="Lucida Console" size=1>$item1&nbsp;&nbsp;</font></td><td width=$tablewidth height=103 rowspan=4 background="$adcenter/images/sgrid.gif" valign="bottom">~;
while($i<13)
{
	$height=int($timp[$i]/$grat);
	$preresult.=qq~<img src="$adcenter/images/sg1.gif" width=8 height=$height border=1 bordercolor=black>~;
	if ($i<12){$preresult.=qq~<img src="$adcenter/images/sdot.gif">~;}
	$i++;
}
@mmclc=@tclc;
@mmclc=sort ({$b<=>$a} @mmclc);
$maxclc=shift(@mmclc);
if ($maxclc<=10){$itm1=10;$itm2=7.5;$itm3=5;$itm4=2.5;}
elsif ($maxclc<=100){$itm1=100;$itm2=75;$itm3=50;$itm4=25;}
elsif ($maxclc<=1000){$itm1=1000;$itm2=750;$itm3=500;$itm4=250;}
elsif ($maxclc<=10000){$itm1=10000;$itm2=7500;$itm3=5000;$itm4=2500;}
elsif ($maxclc<=100000){$itm1=100000;$itm2=75000;$itm3=50000;$itm4=25000;}
elsif ($maxclc<=1000000){$itm1=1000000;$itm2=750000;$itm3=500000;$itm4=250000;}
$grat=$itm1/100;
$i=1;
$preresult.=qq~</td></tr>
<tr><td valign=top align=right><font face="Lucida Console" size=1>$item2&nbsp;&nbsp;</font></td></tr>
<tr><td valign=top align=right><font face="Lucida Console" size=1>$item3&nbsp;&nbsp;</font></td></tr>
<tr><td valign=top align=right><font face="Lucida Console" size=1>$item4&nbsp;&nbsp;</font></td></tr>
<tr><td valign=top align=right><font face="Lucida Console" size=1>0&nbsp;&nbsp;</font></td><td><img src="$adcenter/images/monbar.gif"></td></tr>
</table></td></tr></table></center></div>
<div align=center><center><table width=$table bgcolor=white cellpadding=0 cellspacing=0 border=1><tr><td><table width=$table bgcolor=white cellpadding=0 cellspacing=0>
<tr><td colspan=2><center><font face="Lucida Console" size=1 color=red><br>Total clicks for $data{year}: $totclc </font><br><br></center></td><td width=60 rowspan=3>&nbsp;</td></tr>
<tr><td valign=top align=right width=60><font face="Lucida Console" size=1>$itm1&nbsp;&nbsp;</font></td><td width=$tablewidth height=103 rowspan=4 background="$adcenter/images/sgrid.gif" valign="bottom">~;
while($i<13)
{
	$height=int($tclc[$i]/$grat);
	$preresult.=qq~<img src="$adcenter/images/sg2.gif" width=8 height=$height border=1 bordercolor=black>~;
	if ($i<12){$preresult.=qq~<img src="$adcenter/images/sdot.gif">~;}
	$i++;
}
$preresult.=qq~</td></tr>
<tr><td valign=top align=right><font face="Lucida Console" size=1>$itm2&nbsp;&nbsp;</font></td></tr>
<tr><td valign=top align=right><font face="Lucida Console" size=1>$itm3&nbsp;&nbsp;</font></td></tr>
<tr><td valign=top align=right><font face="Lucida Console" size=1>$itm4&nbsp;&nbsp;</font></td></tr>
<tr><td valign=top align=right><font face="Lucida Console" size=1>0&nbsp;&nbsp;</font></td><td><img src="$adcenter/images/monbar.gif"></td></tr>
</table></td></tr></table></center></div>~;
&closedb;
open (F,"<$adcpath/template/mmonsts.tpl");
@htmlpage=<F>;
close (F);
$htmlpage=join("",@htmlpage);
$htmlpage="print qq~$htmlpage~;";
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $htmlpage;
exit;
}
sub closedb
{
$sth="";
$dbh="";
}
