#!/usr/bin/perl
use Mysql;

#    ADCenter SQL v1.7 - ads management software
#    Copyright (C) 1998-2010  T&D Systems, Inc.
#    http://www.td-systems.com/
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.

######################################################################
# Variables Section                                                  #
######################################################################
# Reading variables from file
open (F, "<adc.cfg");
@commands=<F>;
close (F);
foreach (@commands)
{
	eval $_;
}

$dbh=Mysql->connect($mysqlhost,$mysqldb,$mysqllogin,$mysqlpassword);
######################################################################
# Main Section                                                       #
######################################################################
# Reading DB and choosing banner
$delay=$delay*60;
if ($delay)
{
	($day,$nmonth,$ndate,$time,$nyear)=split(" ",scalar localtime(time+$delay));
	$ndate="$nyear-$cal{$nmonth}-$ndate $time";
	($day,$month,$date,$time,$year)=split(" ",scalar localtime);
	$date="$year-$cal{$month}-$date $time";
	$sth=$dbh->query("LOCK TABLES adc_ilock WRITE") if ($locktables);
	$sth=$dbh->query("SELECT iid FROM adc_ilock WHERE ip='$ENV{REMOTE_ADDR}'");
	$iid=$sth->fetchrow;
	if ($iid)
	{
		$sth=$dbh->query("SELECT iid FROM adc_ilock WHERE (ip='$ENV{REMOTE_ADDR}' AND ldate<'$date')");
		$iid2=$sth->fetchrow;
		if ($iid2==$iid)
		{
			$cancount=1;
			$sth=$dbh->query("UPDATE adc_ilock SET ldate='$ndate' WHERE iid=$iid");
		}
	}
	else
	{
		$cancount=1;
		$sth=$dbh->query("INSERT INTO adc_ilock (ip,ldate) VALUES ('$ENV{REMOTE_ADDR}','$ndate')");
	}
	$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
}
else
{
	$cancount=1;
}
if ($zoneflag)
{
($zone,$spot)=split("&",$ENV{QUERY_STRING});
if ($zone=~/\D+/)
{
	$sth=$dbh->query("LOCK TABLES adc_zones READ") if ($locktables);
	$sth=$dbh->query("SELECT zid FROM adc_zones WHERE zonename='$zone'");
	$zone=$sth->fetchrow;
	$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
}
($ldate=scalar localtime)=~s/ \d+:\d+:\d+//;
($day,$month,$date,$time,$year)=split(" ",scalar localtime);
$month=$cal{$month};
$month="0".$month if (length($month)==1);
$date="0".$date if (length($date)==1);
$expdate="$year-$month-$date";
($hours)=split(":",$time);
$field="h$hours";
$time=~s/://g;
$sth=$dbh->query("LOCK TABLES adc_users READ, adc_banners READ") if ($locktables);
$sth=$dbh->query("SELECT adc_users.uid,ccred,icred,ratio,bid,urltb,bcode,alt FROM adc_users,adc_banners WHERE (adc_users.uid=adc_banners.uid AND (expdate>'$expdate' OR expdate='0000-00-00') AND stime<$time AND etime>$time AND target LIKE '%,$zone,%')");
while(($uid,$ccred,$icred,$ratio,$bid,$urltb,$bcode,$alt)=$sth->fetchrow)
{
	if ($creditsystem)
	{
		if (($ccred>1 || $icred>1) && ($bcode || $urltb || -e "$adcpath/banners/$bid.gif" || -e "$adcpath/banners/$bid.jpg"))
		{
			$j=0;
			while($j<$ratio)
			{
				push(@found,"$uid\t$bid\t$urltb\t$bcode\t$alt");
				$j++;
			}
		}
	}
	else
	{
		if ($bcode || $urltb || -e "$adcpath/banners/$bid.gif" || -e "$adcpath/banners/$bid.jpg")
		{
			$j=0;
			while($j<$ratio)
			{
				push(@found,"$uid\t$bid\t$urltb\t$bcode\t$alt");
				$j++;
			}
		}
	}
}
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
unless (@found)
{
	$sth=$dbh->query("LOCK TABLES adc_users READ, adc_banners READ") if ($locktables);
	$sth=$dbh->query("SELECT adc_users.uid,bid,urltb,bcode,alt FROM adc_users,adc_banners WHERE (adc_users.uid=adc_banners.uid AND username='$yourname')");
	while(($uid,$bid,$urltb,$bcode,$alt)=$sth->fetchrow)
	{
		push(@found,"$uid\t$bid\t$urltb\t$bcode\t$alt");
	}
	$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
}
srand;
($username,$banno,$banurl,$html,$alt)=split("\t",$found[int(rand scalar(@found))]);

#p0ST sTATiSTiCS
if ($creditsystem && $cancount)
{
	$sth=$dbh->query("LOCK TABLES adc_users WRITE") if ($locktables);
	$sth=$dbh->query("UPDATE adc_users SET icred=icred-1 WHERE (uid=$username AND icred>1)");
	$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
}
if ($cancount)
{

	$sth=$dbh->query("LOCK TABLES adc_imp WRITE") if ($locktables);
	$sth=$dbh->query("SELECT sid FROM adc_imp WHERE (uid=$username AND bid=$banno AND statd='$expdate')");
	$sid=$sth->fetchrow;
	unless ($sid)
	{
		$sth=$dbh->query("INSERT INTO adc_imp (uid,bid,statd,h00,h01,h02,h03,h04,h05,h06,h07,h08,h09,h10,h11,h12,h13,h14,h15,h16,h17,h18,h19,h20,h21,h22,h23) VALUES ($username,$banno,'$expdate',0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0)");
	}
	$sth=$dbh->query("UPDATE adc_imp SET $field=$field+1 WHERE (uid=$username AND bid=$banno AND statd='$expdate')");
	$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
}
if ($html)
{
	$bv=$html;
}
elsif ($banurl)
{
	$bv=qq~<a href="$cgi/adcredir.pl?$username&$banno" target="$target"><img src="$banurl" alt="$alt" border=0></a><br><a href="$cgi/adcredir.pl?$username&$banno" target="$target">$alt</a>~;
}
elsif (-e "$adcpath/banners/$banno.gif")
{
	$bv=qq~<a href="$cgi/adcredir.pl?$username&$banno" target="$target"><img src="$adcenter/banners/$banno.gif" alt="$alt" border=0></a><br><a href="$cgi/adcredir.pl?$username&$banno" target="$target">$alt</a>~;
}
else
{
	$bv=qq~<a href="$cgi/adcredir.pl?$username&$banno" target="$target"><img src="$adcenter/banners/$banno.jpg" alt="$alt" border=0></a><br><a href="$cgi/adcredir.pl?$username&$banno" target="$target">$alt</a>~;
}
&closedb;
$bv=~s/'/\\'/g;
print "HTTP/1.0 200 OK\n";
print "content-type: application/x-javascript\n\n";
print qq~document.write('$bv');~;

}
else
{
($spot)=split("&",$ENV{QUERY_STRING});
($ldate=scalar localtime)=~s/ \d+:\d+:\d+//;
($day,$month,$date,$time,$year)=split(" ",scalar localtime);
$month=$cal{$month};
$month="0".$month if (length($month)==1);
$date="0".$date if (length($date)==1);
$expdate="$year-$month-$date";
($hours)=split(":",$time);
$field="h$hours";
$time=~s/://g;
$tpage=$ENV{HTTP_REFERER};
$sth=$dbh->query("LOCK TABLES adc_users READ, adc_banners READ") if ($locktables);
$sth=$dbh->query("SELECT adc_users.uid,ccred,icred,ratio,bid,urltb,target,alt,bcode FROM adc_users,adc_banners WHERE (adc_users.uid=adc_banners.uid AND (expdate>'$expdate' OR expdate='0000-00-00') AND stime<$time AND etime>$time)");
while(($uid,$ccred,$icred,$ratio,$bid,$urltb,$target,$alt,$bcode)=$sth->fetchrow)
{
	if ($creditsystem)
	{
		if (($ccred>1 || $icred>1) && ($bcode || $urltb || -e "$adcpath/banners/$bid.gif" || -e "$adcpath/banners/$bid.jpg") && ($target=~/$tpage/ || !$tpage))
		{
			$j=0;
			while($j<$ratio)
			{
				push(@found,"$uid\t$bid\t$urltb\t$bcode\t$alt");
				$j++;
			}
		}
	}
	else
	{
		if (($bcode || $urltb || -e "$adcpath/banners/$bid.gif" || -e "$adcpath/banners/$bid.jpg") && ($target=~/$tpage/ || !$tpage))
		{
			$j=0;
			while($j<$ratio)
			{
				push(@found,"$uid\t$bid\t$urltb\t$bcode\t$alt");
				$j++;
			}
		}
	}
}
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
unless (@found)
{
	$sth=$dbh->query("LOCK TABLES adc_users READ, adc_banners READ") if ($locktables);
	$sth=$dbh->query("SELECT adc_users.uid,bid,urltb,alt,bcode FROM adc_users,adc_banners WHERE (adc_users.uid=adc_banners.uid AND username='$yourname')");
	while(($uid,$bid,$urltb,$alt,$bcode)=$sth->fetchrow)
	{
		push(@found,"$uid\t$bid\t$urltb\t$bcode\t$alt");
	}
	$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
}
srand;
($username,$banno,$banurl,$html,$alt)=split("\t",$found[int(rand scalar(@found))]);

#p0ST sTATiSTiCS
if ($creditsystem && $cancount)
{
	$sth=$dbh->query("LOCK TABLES adc_users WRITE") if ($locktables);
	$sth=$dbh->query("UPDATE adc_users SET icred=icred-1 WHERE (uid=$username AND icred>1)");
	$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
}
if ($cancount)
{

	$sth=$dbh->query("LOCK TABLES adc_imp WRITE") if ($locktables);
	$sth=$dbh->query("SELECT sid FROM adc_imp WHERE (uid=$username AND bid=$banno AND statd='$expdate')");
	$sid=$sth->fetchrow;
	unless ($sid)
	{
		$sth=$dbh->query("INSERT INTO adc_imp (uid,bid,statd,h00,h01,h02,h03,h04,h05,h06,h07,h08,h09,h10,h11,h12,h13,h14,h15,h16,h17,h18,h19,h20,h21,h22,h23) VALUES ($username,$banno,'$expdate',0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0)");
	}
	$sth=$dbh->query("UPDATE adc_imp SET $field=$field+1 WHERE (uid=$username AND bid=$banno AND statd='$expdate')");
	$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
}
if ($html)
{
	$bv=$html;
}
elsif ($banurl)
{
	$bv=qq~<a href="$cgi/adcredir.pl?$username&$banno" target="$target"><img src="$banurl" alt="$alt" border=0></a><br><a href="$cgi/adcredir.pl?$username&$banno" target="$target">$alt</a>~;
}
elsif (-e "$adcpath/banners/$banno.gif")
{
	$bv=qq~<a href="$cgi/adcredir.pl?$username&$banno" target="$target"><img src="$adcenter/banners/$banno.gif" alt="$alt" border=0></a><br><a href="$cgi/adcredir.pl?$username&$banno" target="$target">$alt</a>~;
}
else
{
	$bv=qq~<a href="$cgi/adcredir.pl?$username&$banno" target="$target"><img src="$adcenter/banners/$banno.jpg" alt="$alt" border=0></a><br><a href="$cgi/adcredir.pl?$username&$banno" target="$target">$alt</a>~;
}
&closedb;
$bv=~s/'/\\'/g;
$bv=~s/\r//g;
$bv=~s/\n//g;
print "HTTP/1.0 200 OK\n";
print "content-type: application/x-javascript\n\n";
print qq~document.write('$bv');~;
}
sub closedb
{
$sth="";
$dbh="";
}
